<template>
    <BaseInput
        class="root"
        :key="changeKey"
        type="text"
        :value="inputValue"
        :left-label="currencySymbol"
        :input-classes="{'currency-input': true}"
        :placeholder="placeholder"
        :aria-label="placeholder"
        :required="required"
        :disabled="disabled"
        step="0.01"
        @input-change="onInputChange"
        @input-blur="onBlurRevalidateCurrencyDisplay"
    />
</template>

<script lang="ts">
import "reflect-metadata";
import { Vue, Component, Prop } from "vue-property-decorator";
import Money, { Currency } from "tpfs-money";

import currencyDataLookup from "@/lib/currencyDataLookup";

@Component
export default class CurrencyInput extends Vue {
  @Prop({ default: "0.00" }) public readonly placeholder!: string;
  @Prop({ default: "USD", type: String }) public readonly currency!: Currency;
  @Prop({ default: "" }) public readonly initialValue!: string;
  @Prop({ default: true }) public readonly required!: boolean;
  @Prop({ default: false }) public readonly disabled!: boolean;

  public inputValue: string = this.initialValue;
  public currentValue: Money = Money.fromMajorUnits(
    this.initialValueOrDefault,
    this.currency
  );
  public changeKey: number = 0;

  get initialValueOrDefault() {
    return this.initialValue || "0.00";
  }

  get currencySymbol() {
    const currencyData = currencyDataLookup.get(this.currency);
    return currencyData ? currencyData.symbol : undefined;
  }

  get currentStringValue() {
    return Money.displayDecimal("en-US", this.currentValue.amountInMinorUnits);
  }

  get strippedInputValue() {
    return this.inputValue.replace(/[^\d.]/g, "");
  }

  public onInputChange(s: string) {
    this.inputValue = s;
    try {
      const newValue = Money.fromMajorUnits(
        this.strippedInputValue || 0,
        this.currency
      );
      this.currentValue = newValue;
    } catch (e) {
      this.inputValue = this.strippedInputValue;
      this.currentValue = new Money(0, "USD");
      this.$emit("amount-invalid", e);
    }
    this.$emit("amount-change", this.currentValue);
  }

  public onBlurRevalidateCurrencyDisplay() {
    // Show '0.00' placeholder instead of actual '0.00' value if input is deleted entirely
    if (this.inputValue) {
      this.inputValue = this.currentStringValue;
    }
    this.changeKey += 1;
  }
}
</script>

<style lang="scss" scoped>
    .root ::v-deep .currency-input {
        min-height: 60px;
    }
</style>
